/*********************************************************************
 * NGram-Analysis Tool v1.9
 *
 * Copyright (c) 2001
 *      Robert Hoehndorf <mai01alq@informatik.uni-leipzig.de>
 *      All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by the Robert Hoehndorf
 *    and his contributors.
 * 4. Neither the name of the author nor the names of his contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Note: Prior versions of this tool stood under the GNU General Public
 *   License. Some people contributed code to this version. I will no
 *   longer support this version, but you will still find the code of
 *   these versions on my website.
 *   This code does not contain anything written under the GPL.
 *
 *********************************************************************/


#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "ngram.h"

int mfgets(char* t,int n,FILE* fp);

int filesize(char* fn) {
  int i=0;
  FILE* fp=fopen(fn,"r");
  i=ftell(fp);
  fseek(fp,0,SEEK_END);
  i-=ftell(fp);
  fclose(fp);
  return -i;
}

int max(int a, int b) {
  return a>b?a:b;
}

void buildNgram(char* fn1,char* fn2,int n) {
  FILE* fp;
  int i=0;int j;
  int k;
  char* ng;
  long long sum;
  struct stackelem *temp;
  
  ngram1=NULL;
  ngram2=NULL;

  ngram1=malloc(sizeof(struct node));
  ngram2=malloc(sizeof(struct node));
  for (i=0;i<256;i++) {
    ngram1->next[i].n=NULL;
    ngram2->next[i].n=NULL;
  }


  ng=malloc(sizeof(char)*(n+1));

  fp=fopen(fn1,"r");
  fseek(fp,0,SEEK_END);
  j=ftell(fp)-n-1;
  for (i=0;i<j;i++) {
    /* DEBUGGING */
    fseek(fp,i,SEEK_SET);
    mfgets(ng,n,fp);
    insert(ngram1,ng,n);
  }
  fclose(fp);

  fp=fopen(fn2,"r");
  fseek(fp,0,SEEK_END);
  j=ftell(fp)-n-1;  
  for (i=0;i<j;i++) {
    /* DEBUGGING */
    fseek(fp,i,SEEK_SET);
    mfgets(ng,n,fp);
    insert(ngram2,ng,n);
  }
  fclose(fp);
}

int mfgets(char* t,int n,FILE* fp) {
  char ch;
  char b=0;
  int i=0;
  while ((!feof(fp))&&(ch=fgetc(fp))&&(1+n-i)) {
    if ((((ch==' ')||(ch=='\n'))&&b)||((!(isalpha(ch)))&&(ch!='\n')&&(ch!=' ')))
      continue;
    else 
      if ((ch==' ')||(ch=='\n'))
	b++;
      else 
	b=0;
    t[i++]=ch;
  }
  t[n]='\0';
  fflush(stdin);
  fflush(fp);
  return n;
}

int main(int argc,char* argv[]) {
  int n;
  long int sum1, sum2;
  if (argc!=4) {
    printf("Usage: ngram <file1> <file2> <n>\n");
    return -1;
  }
  sscanf(argv[3],"%i",&n);
  buildNgram(argv[1],argv[2],n);
  sum1=sumcount(ngram1,n);
  sum2=sumcount(ngram2,n);

  printf("Distanz: %f\n",dist(ngram1,ngram2,n, sum1, sum2));
  return 1;
}

