
#include <stdlib.h>
#include "tree.h"
#include <stdio.h>

/* This function inserts the ngram s of length n in the tree pointed
   to by tree
*/
void insert(struct node* tree,char* s,unsigned int n) {
  int i=0;
  int j=0;
  struct node* nxt=tree;
  struct node* temp=NULL;
  struct leaf* l=NULL;
  if (!nxt) {
    nxt=malloc(sizeof(struct node));
    for (i=0;i<256;i++) {
      nxt->next[i].n=NULL;
    }
  }
  for (i=0;i<n-1;i++) {
    if (nxt->next[(int)s[i]].n) { /* Test, if next-pointer is not NULL */
      nxt=nxt->next[(int)s[i]].n;
    } else { /* insert new node */
      temp=malloc(sizeof(struct node));
      nxt->next[(int)s[i]].n=temp;
      for (j=0;j<256;j++) {
	temp->next[j].n=NULL;
      }
      nxt=temp;
    }
  }
  /* From here on we have to treat the leaves */
  if (nxt->next[(int)s[n-1]].l) {
    l=nxt->next[(int)s[n-1]].l;
    l->count++;
  } else {
    l=malloc(sizeof(struct leaf));
    l->count=0;
    nxt->next[(int)s[n-1]].l=l;
  }
}

/* This function sums up all count-values of the tree pointed to by tree*/
/* Max-Depth will be n */
long int sumcount(struct node* tree, unsigned int n) {
  int i=0;
  long int sum=0;
  if (n>1) {
    for (i=0;i<256;i++) {
      if (tree&&tree->next[i].n) {
	sum+=sumcount(tree->next[i].n,n-1);
      }
    }
  } else {
    for (i=0;i<256;i++) {
      if (tree&&tree->next[i].l) {
	sum=(tree->next[i].l)->count;
      }
    }
  }
  return sum;
}

inline double sqr(double a) {
  return a*a;
}

/* Fucking bug somewhere... maybe rounding does not work right... */
double dist(struct node* t1,struct node* t2, unsigned int n, long sum1, long sum2) {
  int i;
  double d=0.0;
  if (n>1) {
    for (i=0;i<256;i++) {
      if (t1||t2) {
	d+=dist(t1?t1->next[i].n:NULL,t2?t2->next[i].n:NULL,n-1,sum1,sum2);
      }
    }
  } else {
    for (i=0;i<256;i++) {
      if (t1&&t1->next[i].l && t2&&t2->next[i].l) {
	d=sqrt(abs(sqr(((double)t1->next[i].l->count)/(double)sum1)-sqr(((double)t2->next[i].l->count)/(double)sum2)));
      } else if (t1&&t1->next[i].l) {
	d=((double)t1->next[i].l->count)/((double)sum1);
      } else if (t2&&t2->next[i].l) {
	d=((double)t2->next[i].l->count)/((double)sum2);
      }
    }
  }
  return d;
}
